<?php
// Function to get the Bearer Token
function getBearerToken($url, $credentials) {
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($credentials));
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Content-Type: application/x-www-form-urlencoded'
    ]);

    $response = curl_exec($ch);
    curl_close($ch);

    $data = json_decode($response, true);
    if (isset($data['token'])) {
        return $data['token'];
    } else {
        throw new Exception("Unable to get token. Response: " . $response);
    }
}

// Define the URL and credentials for the token request
$tokenUrl = "http://adentrn.worksafeonline.co.uk/api/Token";
$credentials = [
    'username' => 'support.sss', // Replace with actual username
    'password' => 'simplesoft21'  // Replace with actual password
];

try {
    // Get the Bearer Token
    $token = getBearerToken($tokenUrl, $credentials);

    // Get variables from AJAX request
    $quoteNo = isset($_GET['quoteNo']) ? (int)$_GET['quoteNo'] : 0;
    $style = isset($_GET['style']) ? $_GET['style'] : '';
    $salesp = isset($_GET['salesp']) ? (int)$_GET['salesp'] : 0;
    $all = isset($_GET['all']) ? (int)$_GET['all'] : 0;
    $uplift = isset($_GET['uplift']) ? (int)$_GET['uplift'] : 0;
    $customer = isset($_GET['customer']) ? $_GET['customer'] : '';
    $addr = isset($_GET['addr']) ? $_GET['addr'] : '';
    $line = isset($_GET['line']) ? (int)$_GET['line'] : 0;

    // Construct the URL with the query parameters
    $saveUrl = "http://adentrn.worksafeonline.co.uk/api/AddQuotationStyle?" .
               "quoteNo=" . urlencode($quoteNo) .
               "&style=" . urlencode($style) .
               "&salesp=" . urlencode($salesp) .
               "&all=" . urlencode($all) .
               "&uplift=" . urlencode($uplift) .
               "&customer=" . urlencode($customer) .
               "&addr=" . urlencode($addr) .
               "&line=" . urlencode($line);

    // Initialize cURL
    $ch = curl_init();

    // Set the URL and options for GET request
    curl_setopt($ch, CURLOPT_URL, $saveUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Authorization: Bearer ' . $token
    ]);

    // Execute the request
    $response = curl_exec($ch);

    // Check for errors
    if (curl_errno($ch)) {
        throw new Exception(curl_error($ch));
    }

    // Close cURL
    curl_close($ch);

    // Return the response
    header('Content-Type: application/json'); // Set content type to JSON
    echo $response;

} catch (Exception $e) {
    // Return error in JSON format
    header('Content-Type: application/json'); // Set content type to JSON
    echo json_encode(["error" => $e->getMessage()]);
}
?>
