<?php
class AddUser {
    private $pdo;

    public function __construct($pdo) {
        $this->pdo = $pdo;
    }

    public function createUser($name, $email, $password, $type) {
        try {
            $stmt = $this->pdo->prepare("INSERT INTO user_accounts (name, email, type, password, created) VALUES (:name, :email, :type, :password, :created)");
            $stmt->execute([
                ':name' => $name,
                ':email' => $email,
                ':type' => $type,
                ':password' => password_hash($password, PASSWORD_DEFAULT),
                ':created' => date('Y-m-d')
            ]);
            if($stmt->rowCount() == 1){
            return true;
            }else{
                return false;
            }
        } catch (Exception $e) {
            return false;
        }
    }
    
    
    public function getUsers() {
        try {
            $stmt = $this->pdo->prepare("SELECT id, name, email, type, created FROM user_accounts ORDER BY id DESC");
            $stmt->execute();
            return $stmt->fetchAll(PDO::FETCH_ASSOC);
        } catch (Exception $e) {
            return false;
        }
    }

    
    public function deleteUser($id) {
        try {
            $stmt = $this->pdo->prepare("DELETE FROM user_accounts WHERE id = :id");
            $stmt->execute([':id' => $id]);
            return true;
        } catch (Exception $e) {
            return false;
        }
    }
    
    
    public function updateUser($id, $name, $email, $type) {
        try {
            $stmt = $this->pdo->prepare("UPDATE user_accounts SET name = :name, email = :email, type = :type WHERE id = :id");
            $stmt->execute([
                ':name' => $name,
                ':email' => $email,
                ':type' => $type,
                ':id' => $id
            ]);
            return true;
        } catch (Exception $e) {
            return false;
        }
    }


}
?>
