<?php
class GetRequestAPIModel {
    private $tokenUrl;
    private $credentials;
    private $token;

    public function __construct($tokenUrl, $credentials) {
        $this->tokenUrl = $tokenUrl;
        $this->credentials = $credentials;
    }

    public function getBearerToken() {
        if (isset($this->token)) {
            return $this->token;
        }

        $ch = curl_init($this->tokenUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($this->credentials));
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/x-www-form-urlencoded'
        ]);

        $response = curl_exec($ch);
        curl_close($ch);

        $data = json_decode($response, true);
        if (isset($data['token'])) {
            $this->token = $data['token'];
            return $this->token;
        } else {
            throw new Exception("Unable to get token. Response: " . $response);
        }
    }

    public function fetchData($url) {
        $token = $this->getBearerToken();
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            "Authorization: Bearer $token"
        ]);

        $response = curl_exec($ch);
        curl_close($ch);

        return json_decode($response, true);
    }
}
?>
